package model;

import java.util.ArrayList;

public class Nwap extends Pawn {

    private boolean enPassant;
    public Nwap(Position p, int color) {
        super(p, color);
        enPassant = false;
    }

    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {


        ArrayList<Position> moves = new ArrayList<Position>();
        Position arrival;
        Position arrival2;

        if(color == Piece.WHITE) { // black and white have an opposite direction behavior

            if(!hasBeenMoved){

                //	up left 2


                //	up right 2

            }
            //	up left 1
            arrival = new Position(p.getX()-1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) {

                 arrival2 = new Position(p.getX()-2, p.getY() +2);
                if(arrival2.isCorrect() && b.isFree(arrival2)) { moves.add(arrival2); }
                moves.add(arrival); }


            //	up right 1
            arrival = new Position(p.getX()+1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                arrival2 = new Position(p.getX()+2, p.getY() +2);
                if(arrival2.isCorrect() && b.isFree(arrival2)) { moves.add(arrival2); }
                moves.add(arrival); }

            arrival = new Position(p.getX(),p.getY()+1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}

        }
        else {


            if(!hasBeenMoved){




            }
            //	up left 1
            arrival = new Position(p.getX()-1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                //	up left 2
                arrival2 = new Position(p.getX()-2, p.getY() -2);
                if(arrival2.isCorrect() && b.isFree(arrival2)) { moves.add(arrival2); }
                moves.add(arrival); }


            //	up left 1
            arrival = new Position(p.getX()+1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) {

                //	up left 2
                arrival2 = new Position(p.getX()+2, p.getY() -2);
                if(arrival2.isCorrect() && b.isFree(arrival2)) { moves.add(arrival2); }moves.add(arrival); }


            arrival = new Position(p.getX(),p.getY()-1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}

        }
        return moves;
    }
    public boolean isEnPassant() {
        return enPassant;
    }

    public void setEnPassant(boolean enPassant) {
        this.enPassant = enPassant;
    }

    public Piece newInstanceCopy() {
        return new Nwap(p, color);
    }
}
